Attribute VB_Name = "ModuloUp"
Option Explicit
'/////////////////////////////////////////////////// PER SHELL
Public Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type
Public Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessID As Long
    dwThreadID As Long
End Type

Public Const RAS_MAXENTRYNAME = 256
Public Const RAS_MAXDEVICETYPE = 16
Public Const RAS_MAXDEVICENAME = 128
Public Const RAS_RASCONNSIZE = 412

Public Type RasConn
    dwSize As Long
    hRasConn As Long
    szEntryName(RAS_MAXENTRYNAME) As Byte
    szDeviceType(RAS_MAXDEVICETYPE) As Byte
    szDeviceName(RAS_MAXDEVICENAME) As Byte
End Type

Public Declare Function RasEnumConnections Lib "rasapi32.dll" Alias "RasEnumConnectionsA" (lpRasConn As Any, lpcb As Long, lpcConnections As Long) As Long

Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function CreateProcessA Lib "kernel32" (ByVal _
        lpApplicationName As Long, ByVal lpCommandLine As String, ByVal _
        lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, _
        ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, _
        ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, _
        lpStartupInfo As STARTUPINFO, lpProcessInformation As _
        PROCESS_INFORMATION) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
    
Public Const NORMAL_PRIORITY_CLASS = &H20&
Public Const INFINITE = -1&
'/////////////////////////////////////////////////////////////////// PER Controllo Connessione

Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const ERROR_SUCCESS = 0&
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public NEWVErsion As String

Public Const MAX_PATH As Long = 260
Public Const LB_SETTABSTOPS As Long = &H192
Public Declare Function EnumWindows Lib "User32.dll" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function GetWindowText Lib "User32.dll" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "User32.dll" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Public Declare Function SendMessage Lib "User32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public SPOnEx As Boolean    'Serve per verificare se Spegni Pc  gi in esecuzione
Public Function SPEsecuzione(ByVal hWnd As Long, ByVal lParam As Long) As Boolean
    Dim nSize As Long
    Dim sTitle As String
    Dim pos As Integer
    sTitle = Space$(MAX_PATH)
    Call GetWindowText(hWnd, sTitle, MAX_PATH)
    pos = InStr(sTitle, Chr$(0))
    If pos Then
        sTitle = Left$(sTitle, pos - 1)
    Else
        sTitle = ""  'Non aggiunge il carattere di tabulazione, poich  l'ultimo elemento della linea.
    End If
    If InStr(1, sTitle, "Spegni Computer") > 0 Then
        SPOnEx = True
    End If
    SPEsecuzione = True
End Function

'#########################################################
'Funzione per lanciare un programma in sincrono.
'Il programma lanciato in finestra viene 'atteso' per
'tutta la sua durata.
'Una funzione usata per lanciare un programma MS-DOS
'e attendere la sua fine.
'1998 by Berardi Paolo
'Email pberardi@nt.kjws.com
'##########################################################################
Public Sub ShellAndWait(ByVal RunProg As String)
Dim RetVal As Long, proc As PROCESS_INFORMATION, StartInf As STARTUPINFO
StartInf.cb = Len(StartInf)
'Crea sessione del programma da lanciare
RetVal = CreateProcessA(0&, RunProg, 0&, 0&, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, StartInf, proc)
RetVal = WaitForSingleObject(proc.hProcess, INFINITE)
RetVal = CloseHandle(proc.hProcess)
End Sub
Public Sub CrackURL(strURL As String, strFilePath As String)
Dim intPos As Integer
If Left$(strURL, 7) = "http://" Then strURL = Right$(strURL, Len(strURL) - 7)
intPos = InStr(1, strURL, "/")
If intPos > 0 Then
    strFilePath = Right$(strURL, Len(strURL) - intPos + 1)
    strURL = Left$(strURL, intPos - 1)
End If
End Sub

Public Function TrimString(s As String) As String
  TrimString = Left$(s, InStr(1, s, Chr$(0)) - 1)
End Function
Public Function PathApp() As String
PathApp = IIf(Right$(App.Path, 1) <> "\", App.Path & "\", App.Path)
End Function
Public Function LeggiVersioneLocale() As String
On Error Resume Next
Open PathApp & "versionSP.dat" For Input As #1
Input #1, LeggiVersioneLocale: Close #1
Close #1
End Function
Public Function LeggiVersioneOnLine(ByVal CartellaTemp) As String
Dim tmp$
On Error Resume Next
Open CartellaTemp & "SPVersion" For Binary As #1
Input #1, tmp$: Close #1
Close #1
LeggiVersioneOnLine = Trim$(tmp$)
End Function
Public Function ConfrontoVersioni(ByVal Vers1 As String, ByVal vers2 As String) As Boolean 'True se  da Aggiornare
'VERSIONE2  quello letto da Internet
Dim a() As String, b() As String
NEWVErsion = vers2
a = Split(Vers1, ".")
b = Split(vers2, ".")
ConfrontoVersioni = False
If Val(a(0)) < Val(b(0)) Or Val(a(1)) < Val(b(1)) Or Val(a(2)) < Val(b(2)) Then ConfrontoVersioni = True
End Function
